#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include "gc.h"

void getmem(void);      /* mmap() some memory and assign to the GC ptrs      */

/*
 * Here come the global pointers, I hope this is all of em.
 * Why do I have to bother with the char * and void *'s anyways? I'm 
 * starting to get really annoyed with them. :)
 */

mem fromspace;          /* The place where objects are copied from by the GC */
mem tospace;            /* tospace is where objects are copied to/created    */
cell *free;             /* The bottom of the available free space in tospace */
cell *scanptr;          /* The address of the next cell to be scanned        */
cell *top;              /* Pointer to the top of the free space in tospace   */
mem _top;               /* These are used to make sure we know the absolute  */
mem _bottom;            /* start/end of the memory block (just in case)      */

int k = 10;              /* Ratio of GC's per CONS. Higher = more, slower    */

/* We'll try stacks later */
/*int stack_top = 0;*/  /* The top element of the stack                      */
/*int stack_scan = 0;*/ /* The latest stack element to be scanned            */

char *progname;

int main(int argc, char *argv[]) {
  cell *foo, *bar, *baz, *blah;

  progname = argv[0];     /* I hate this. */
  getmem();

  dump_ptrs(); /* We want to see the allocations, so print the initial ptrs */
  foo = cons(NULL, NULL);dump_ptrs();    /* Lame tests. I definitly need    */
  bar = cons(NULL, NULL);dump_ptrs();    /* some type of scheme interpreter */
  baz = cons(NULL, NULL);dump_ptrs();    /* or something to test with.      */
  blah = cons(NULL, NULL);dump_ptrs();

  replacd(foo, bar);
  replacd(bar, baz);
  replacd(baz, foo);
  dump_ptrs();
  replaca(foo, (mem)foo);
  replaca(bar, (mem)foo);
  replaca(baz, (mem)foo);
  dump_ptrs();

  flip();  /* switch the (from/to)spaces. My mmap file is much too big */
  blah = cdr(foo);
  blah = cons(foo, bar);
  blah = cons(foo, bar);
  blah = cons(foo, bar);

  dump_ptrs();

  return 0;
}

void getmem(void) {
  int fd;

  if((fd = open(MMAP_FILE, O_RDWR)) == -1) {
    perror(progname);
    exit(-1);
  }
  if((_bottom = mmap((caddr_t) 0, MMAP_LEN, PROT_READ|PROT_WRITE,
		      MAP_SHARED|MAP_FILE, fd, 0)) == (caddr_t) -1) {
    perror(progname);
    exit(-1);
  }

  _top        = _bottom+MMAP_LEN;
  tospace     = _bottom;
  free        = tospace;
  fromspace   = _bottom + SPACE_SIZE;
  top         = (cell *) (tospace + (SPACE_SIZE - sizeof(cell)));  /* UGH! */
  scanptr     = tospace;
}

void dump_ptrs(void) {
  printf(
"_bottom:\t%p
_top:\t\t%p
free:\t\t%p
fromspace:\t%p
tospace:\t%p
scanptr:\t%p
top:\t\t%p
", _bottom, _top, free, fromspace, tospace, scanptr, top);
}

void error(char *error) {
  printf(error);
  dump_ptrs();
  exit(-1);
}
