#include "gc.h"

/* There's alot of debugging code in here, but there's lots to debug. */

cell *cons(mem new_car, cell *new_cdr) {
  int i;

#if DEBUG
  printf("cons(%p, %p);\n", new_car, new_cdr);
#endif
  if(free == top) {
    if(scanptr < free) error("scanptr < free???\n");
    flip();
    new_car = move(new_car);
    new_cdr = move(new_cdr);
  }
#if DEBUG
  printf("%p < %p?\n", scanptr, free);
#endif
  for(i = 0; i < k && (mem)scanptr < (mem)free; i++) {
    car(scanptr);
    cdr(scanptr);
    scanptr += 1;
  }
  if(free == top) error("free == top??\n");
  top -= 1;
  top->car = new_car;
  top->cdr = new_cdr;
  return top;
}

void flip(void) {  /* 'flip' the spaces. No error-checking, quick and dirty */
#if DEBUG
  printf("flip()\n");
#endif
  free        = tospace;
  tospace     = fromspace;
  fromspace   = free;
  free        = tospace;
  top         = (tospace + (SPACE_SIZE - sizeof(cell)));  /* UGH! */
  scanptr     = tospace;
#if DEBUG
  dump_ptrs();
#endif
}

mem move(cell *p) {
#if DEBUG
  printf("move(%p)\n",p);
#endif
  if(!in_fromspace(p)) return p;
  else {
#if DEBUG
    printf("We're in fromspace, move me\n");
    printf("if(!in_tospace(%p)) p->car = copy(%p);\n",((cell *)p)->car,p);
#endif
    if(!in_tospace(((cell *)p)->car)) ((cell *)p)->car = copy(p);
#if DEBUG
    dump_ptrs();
#endif
    return ((cell *)p)->car;
  }
}

mem copy(mem p) {
#if DEBUG
  printf("copy(%p)\n",p);
#endif
  if(free >= top) error("free >= top???\n");
  free->car = (mem)((long *)p)[0]; /* This is the typecast from hell */
  free->cdr = (cell *)((long *)p)[1]; /* Save me!!!  */
  free += 1;
  return free - sizeof(cell);  /* I like B & (B:=B+2) better, don't you? */
}

int in_fromspace(mem p) {
#if DEBUG
  printf("in_fromspace(%p)\n%p >= %p\n", p, p, fromspace);
#endif
  if(p >= fromspace) {
#if DEBUG
    printf("if(%p > %p || %p < %p) return 1;\n",fromspace,tospace,p,tospace);
#endif
    if(fromspace > tospace || p < tospace) return 1;
    else return 0;
  }
  else return 0;
}

int in_tospace(mem p) {
  if(p >= tospace) {
    if(tospace > fromspace || p < fromspace) return 1;
    else return 0;
  }
  else return 0;
}

car_ptr car(cell *p) { return p->car = move(p->car); }
mem cdr(cell *p)     { return p->cdr = move(p->cdr); }
int atom(mem p)      { return !in_tospace(p); }
int eq(mem x, mem y) { return (x == y) ? 1 : 0; }
void replaca(cell *x, mem *y) { x->car = y; }
void replacd(cell *x, cell *y) { x->cdr = y; }
